#include <stdio.h>
#include <stdlib.h>

#include "../inc/net_types.h"
#include "../inc/generic_types.h"
#include "../library/services/time_synchronisation/ptp.h"
int main(void)
{
    printf("\nSytem Types\n");
    printf("\tchar          :%lu\n", sizeof(char));
    printf("\tshort         :%lu\n", sizeof(short));
    printf("\tint           :%lu\n", sizeof(int));
    printf("\tlong          :%lu\n", sizeof(long));
    printf("\tlong int      :%lu\n", sizeof(long int));
    printf("\tlong long     :%lu\n", sizeof(long long));
    printf("\tlong long int :%lu\n", sizeof(long long int));

    printf("\nDefined Data Types\n");
    printf("\t  int8_t : %lu\n", sizeof(int8_t));
    printf("\t uint8_t : %lu\n", sizeof(uint8_t));
    printf("\t int16_t : %lu\n", sizeof(int16_t));
    printf("\tuint16_t : %lu\n", sizeof(uint16_t));
    printf("\t int32_t : %lu\n", sizeof(int32_t));
    printf("\tuint32_t : %lu\n", sizeof(uint32_t));
    printf("\t int64_t : %lu\n", sizeof(int64_t));
    printf("\tuint64_t : %lu\n", sizeof(uint64_t));
    
    printf("\nPacket data types:\n");
    printf("\tEtherType:%lu\n", sizeof(ethertype_t));
    printf("\tethernet_header_t with vlan:%lu\n", sizeof(ethernet_header_t));
    printf("\tarp_msg_t:%lu\n", sizeof(arp_msg_t));
    printf("\tarp_operation_t:%lu\n", sizeof(arp_msg_t));
    printf("\tipv4_header_t:%lu\n", sizeof(ipv4_header_t));
    printf("\tudp_header_t:%lu\n", sizeof(udp_header_t));

    printf("\nPTP message types:\n");
    printf("\tptp_flags_t:%lu\n", sizeof(ptp_flags_t));
    printf("\tptp_clock_identity_t:%lu\n", sizeof(ptp_clock_identity_t));
    printf("\tptp_port_identity_t:%lu\n", sizeof(ptp_port_identity_t));
    printf("\tptp_header:%lu\n", sizeof(ptp_header_t));
    printf("\tptp_announce_msg_t:%lu\n", sizeof(ptp_announce_msg_t));
    printf("\tptp_sync_msg_t:%lu\n", sizeof(ptp_sync_msg_t));
    printf("\tptp_delay_req_msg_t:%lu\n", sizeof(ptp_delay_req_msg_t));
    printf("\tptp_follow_up_msg_t:%lu\n", sizeof(ptp_follow_up_msg_t));
    printf("\tptp_delay_resp_msg_t:%lu\n", sizeof(ptp_delay_resp_msg_t));
    printf("\tptp_pdelay_req_msg_t:%lu\n", sizeof(ptp_pdelay_req_msg_t));
    printf("\tptp_pdelay_resp_msg_t:%lu\n", sizeof(ptp_pdelay_resp_msg_t));
    printf("\tptp_pdelay_resp_follow_up_msg_t:%lu\n", sizeof(ptp_pdelay_resp_follow_up_msg_t));

    return 0;
}