import socket
import threading
import time

def echo_server(server_address, server_port):

    sock = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
    start_time = time.monotonic()

    server = (server_address, server_port)
    sock.bind(server)
    print("Listening on " + server_address + ":" + str(server_port))
    i=0
    while True:
        payload, client_address = sock.recvfrom(1500)
        rcv_time = time.monotonic()
        if(len(payload) > 10):
            print("{:.4f}".format(rcv_time-start_time) + " Msg. No. " +str(i) + ": Echoing '" + str(payload[0:10]) + "...' back to " + str(client_address))
        else:    
            print("{:.4f}".format(rcv_time-start_time) + " Msg. No. " +str(i) + ": Echoing '" + str(payload) + "' back to " + str(client_address))
        # end if
        sent = sock.sendto(payload[0:100], client_address)
        
        i=i+1
    # end while
# end def

#server_address_0 = '172.16.0.100'
#print("server addr 0 : " + server_address_0)
server_address_1 = '172.16.0.200'
print("server addr 1 : " + server_address_1)
server_port = 12345
print("server port : " + str(server_port))

#s0 = threading.Thread(target=echo_server, args=(server_address_0, server_port,))
s1 = threading.Thread(target=echo_server, args=(server_address_1, server_port,))

#s0.daemon = True
s1.daemon = True

#s0.start()
s1.start()

while True:
    time.sleep(1)